



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring Boot Memory Performance</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring Boot Memory Performance</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 16:41:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
The Performance Zone is brought to you in partnership with&nbsp;<a href="https://dzone.com/go?i=83823&amp;u=http%3A%2F%2Fnewrelic.com%2Fdocker-book%3Futm_source%3DZONE%26utm_medium%3Dcontent%26utm_content%3Ddocker-up-and-running%26utm_campaign%3DNonENTGeneric-Q3FY16%26mpc%3DCN-ZONE-generic-EN-Signup-docker-up-and-running" rel="external nofollow noreferrer">New<br />
 Relic</a>. Quickly learn how to use&nbsp;<a href="https://dzone.com/go?i=83823&amp;u=http%3A%2F%2Fnewrelic.com%2Fdocker-book%3Futm_source%3DZONE%26utm_medium%3Dcontent%26utm_content%3Ddocker-up-and-running%26utm_campaign%3DNonENTGeneric-Q3FY16%26mpc%3DCN-ZONE-generic-EN-Signup-docker-up-and-running" rel="external nofollow noreferrer">Docker<br />
 and containers</a>&nbsp;in general to create packaged images for easy management, testing, and deployment of software.</div>
<div>
<p>It has sometimes been suggested that Spring and Spring Boot are “heavyweight”, perhaps just because they allow apps to punch above their weight, providing a lot of features for not very much user<br />
 code. In this article we concentrate on memory usage and ask if we can quantify the effect of using Spring? Specifically we would like to know more about the real overhead of using Spring compared to other JVM applications. We start by creating a basic application<br />
 with Spring Boot, and look at a few different ways to measure it when it is running. Then we look at some comparison points: plain Java apps, apps that use Spring but not Spring Boot, an app that uses Spring Boot but no autoconfiguration, and some Ratpack<br />
 sample apps.</p>
<h2>Vanilla Spring Boot App</h2>
<p>As a baseline we build a static app with a few webjars and&nbsp;<code>spring.resources.enabled=true</code>.<br />
 This is perfectly fine for serving nice-looking static content maybe with a REST endpoint or two. The source code for the app we used to test is&nbsp;<a href="https://github.com/dsyer/spring-boot-memory-blog/blob/master/demo" rel="external nofollow noreferrer">in<br />
 github</a>. You can build it with the&nbsp;<code>mvnw</code>&nbsp;wrapper script if you have a JDK 1.8 available and on your path (<code>mvnw<br />
 package</code>). It can be launched like this:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ java -Xmx32m -Xss256k -jar target/demo-0.0.1-SNAPSHOT.jar</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>The we add some load, just to warm up the thread pools and force all the code paths to be exercised:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ ab -n 2000 -c 4 http://localhost:8080/</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>We can try and limit threads a bit in&nbsp;<code>application.properties</code>:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">server.tomcat.max-threads: 4</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>but in the end it doesn’t make a lot of difference to the numbers. We conclude from the analysis below that it would save at most a MB with the stack size we are using. All the Spring Boot webapps<br />
 we analyse have this same configuration.</p>
<p>We might have to worry about how big the classpath is, in order to estimate what happens to the memory. Despite some claims in the internet that the JVM memory maps all jars on the classpath, we<br />
 actually don’t find any evidence that the size of the classpath has any effect on the running app. For reference, the size of the dependency jars (not including JDK) in the vanilla sample is 18MB:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ jar -tvf  target/demo-0.0.1-SNAPSHOT.jar | grep lib/.*.jar | awk '{tot&#043;=$1;} END {print tot}'</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">18893563</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>This includes Spring Boot Web and Actuator starters, plus 3 or 4 webjars for static resources and the webjar locator. A completely minimal Spring Boot application including Spring and some logging<br />
 but no web server would be around 5MB of jars.</p>
<h3>JVM Tools</h3>
<p>To measure memory usage there are some tools in the JVM. You can get quite a lot of useful information from JConsole or JVisualVM (with the JConsole plugin so you can inspect MBeans).</p>
<p>Heap usage for our vanilla app is a saw tooth, bounded above by the heap size and below by the amount of memory used in a quiescent state. The average weighs in at roughly 25MB for an app under<br />
 load (and 22MB after a manual GC). JConsole also reports 50MB non-heap usage (which is the same as you get from the&nbsp;<code>java.lang:type=Memory</code>&nbsp;MBean).<br />
 The non-heap usage breaks down as Metaspace: 32MB, Compressed Class Space: 4MB, Code Cache: 13MB (you can get these numbers from the&nbsp;<code>java.lang:type=MemoryPool,name=*</code>&nbsp;MBeans).<br />
 There are 6200 classes and 25 threads, including a few that are added by the monitoring tool that we use to measure them.</p>
<p>Here’s a graph of the heap usage from a quiescent app under load,<br /><br />
followed by a manual garbage collection (the double nick in the<br /><br />
middle) and a new equilibrium with a lower heap usage.</p>
<p><img referrerpolicy="no-referrer"src="https://raw.githubusercontent.com/dsyer/spring-boot-memory-blog/master/manual-gc-web.png"></p>
<p>Some tools in the JVM other than JConsole might also be<br /><br />
interesting. The first is&nbsp;<code>jps</code>&nbsp;which is useful for getting the<br /><br />
process id of the app you want to inspect with the other tools:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ jps</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">4289 Jps</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">4330 demo-0.0.1-SNAPSHOT.jar</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>Then we have the&nbsp;<code>jmap</code>&nbsp;histogram:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ jmap -histo 4330 | head</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"> num     #instances         #bytes  class name</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">----------------------------------------------</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">   1:          5241        6885088  [B</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">   2:         21233        1458200  [C</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">   3:          2548        1038112  [I</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">   4:         20970         503280  java.lang.String</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">   5:          6023         459832  [Ljava.lang.Object;</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">   6:         13167         421344  java.util.HashMap$Node</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">   7:          3386         380320  java.lang.Class</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>This data is of limited use because you can’t trace the “big” objects back to their owners. For that you need a more fully featured profiler, like YourKit. YourKit does the aggregation for you and<br />
 presents a list (although the details of how it does that are rather unclear).</p>
<p>Classloader statistics might also be revealing, and&nbsp;<code>jmap</code>&nbsp;has a way to inspect the classloaders<br />
 in an app. It needs to run as root:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ sudo ~/Programs/jdk1.8.0/bin/jmap -clstats 4330</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">Attaching to process ID 4330, please wait...</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">Debugger attached successfully.</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">Server compiler detected.</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">JVM version is 25.60-b23</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">finding class loader instances ..done.</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">computing per loader stat ..done.</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">please wait.. computing liveness....................................liveness analysis may be inaccurate ...</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">class_loader  classes  bytes  parent_loader  alive?  type</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">&lt;bootstrap&gt;21233609965  null  live&lt;internal&gt;</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">0x00000000f4b0d730114760x00000000f495c890deadsun/reflect/DelegatingClassLoader@0x0000000100009df8</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">0x00000000f5a26120114830x00000000f495c890deadsun/reflect/DelegatingClassLoader@0x0000000100009df8</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">0x00000000f52ba3a811472  null  deadsun/reflect/DelegatingClassLoader@0x0000000100009df8</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">0x00000000f5a3052018800x00000000f495c890deadsun/reflect/DelegatingClassLoader@0x0000000100009df8</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">0x00000000f495c890397263629020x00000000f495c8f0deadorg/springframework/boot/loader/LaunchedURLClassLoader@0x0000000100060828</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">0x00000000f5b639b0114730x00000000f495c890deadsun/reflect/DelegatingClassLoader@0x0000000100009df8</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">0x00000000f4b80a30114730x00000000f495c890deadsun/reflect/DelegatingClassLoader@0x0000000100009df8</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">...</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">total = 93630010405986    N/A    alive=1, dead=92    N/A</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>There are loads of “dead” entries, but there is also a warning that the liveness information is not accurate. A manual GC doesn’t get rid of them.</p>
<h3>Kernel Memory Tools</h3>
<p>You would think that a Linux OS would provide plenty of insight into a running process, and it does, but Java processes are notoriously hard to analyse. This&nbsp;<a href="http://stackoverflow.com/questions/561245/virtual-memory-usage-from-java-under-linux-too-much-memory-used" rel="external nofollow noreferrer">popular<br />
 SO link</a>&nbsp;talks about some of the problems in general. Lets have a look at some of the tools that are available and see what they tell us about our app.</p>
<p>First up is the good old&nbsp;<code>ps</code>&nbsp;(the tool you use to look at processes on the command line).<br />
 You can get a lot of the same information from&nbsp;<code>top</code>. Here’s our application process:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ ps -au</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">USER       PID %CPU %MEM    VSZ   RSS TTY      STAT START   TIME COMMAND</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">dsyer     4330  2.4  2.1 2829092 169948 pts/5  Sl   18:03   0:37 java -Xmx32m -Xss256k -jar target/demo-0.0.1-SNAPSHOT.jar</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">...</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>RSS (Resident Set Size) values are in the range 150-190MB according to&nbsp;<code>ps</code>. There is<br />
 a tool called<code>smem</code>&nbsp;that is supposed to give a more sanitized view, and to accurately reflect non-shared memory, but the values there (for instance<br />
 of PSS) aren’t that different. Interestingly the PSS values for a non-JVM process are usually *significantly* lower than RSS, whereas for a JVM they are comparable. The JVM is very jealous of its memory.</p>
<p>A lower level tool is&nbsp;<code>pmap</code>, where we can look at the memory<br /><br />
allocations assigned to a process. Numbers from&nbsp;<code>pmap</code>&nbsp;don’t seem to<br /><br />
make much sense either:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ pmap 4330</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">0000000000400000      4K r-x-- java</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">0000000000600000      4K rw--- java</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">000000000184c000    132K rw---   [ anon ]</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">00000000fe000000  36736K rw---   [ anon ]</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">00000001003e0000 1044608K -----   [ anon ]</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">...</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">00007ffe2de90000      8K r-x--   [ anon ]</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">ffffffffff600000      4K r-x--   [ anon ]</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"> total          3224668K</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>i.e. over 3GB for a process that we know is only using 80MB. Just counting the ‘—–’ entries gives you nearly all the 3GB. At least that’s consistent with the VSZ numbers from&nbsp;<code>ps</code>,<br />
 but not very useful for capacity management.</p>
<p>Someone commented that the RSS values were accurate on his machine, which is interesting. They definitely didn’t work for me (Ubuntu 14.04 on Lenovo Thinkpad). Also, here’s another interesting article<br />
 on&nbsp;<a href="https://www.ibm.com/developerworks/community/blogs/kevgrig/entry/linux_glibc_2_10_rhel_6_malloc_may_show_excessive_virtual_memory_usage?lang=en" rel="external nofollow noreferrer">JVM memory<br />
 stats in Linux</a>.</p>
<h3>Scale Up Processes</h3>
<p>A good test of how much memory is actually being used by a process is to keep launching more of them until the operating system starts to crumple. For example, to launch 40 identical vanilla processes:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ for f in {8080..8119}; do (java -Xmx32m -Xss256k -jar target/demo-0.0.1-SNAPSHOT.jar --server.port=$f 2&gt;&amp;1 &gt; target/$f.log &amp;); done</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>They are all competing for memory resources so it takes them all a while to start, which is fair enough. Once they all start they serve their home pages quite efficiently (51ms latency over a crappy<br />
 LAN at 99th percentile). Once they are up and running, stopping and starting one of the processes is relatively quick (a few seconds not a few minutes).</p>
<p>The VSZ numbers from&nbsp;<code>ps</code>&nbsp;are off the scale (as expected). The RSS numbers look high too:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ ps -au</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">USER       PID %CPU %MEM    VSZ   RSS TTY      STAT START   TIME COMMAND</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">dsyer    27429  2.4  2.1 2829092 169948 pts/5  Sl   18:03   0:37 java -Xmx32m -Xss256k -jar target/demo-0.0.1-SNAPSHOT.jar --server.port=8081</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">dsyer    27431  3.0  2.2 2829092 180956 pts/5  Sl   18:03   0:45 java -Xmx32m -Xss256k -jar target/demo-0.0.1-SNAPSHOT.jar --server.port=8082</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">...</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>RSS values are still in the range 150-190MB. If all 40 processes were indepenently using this much memory that would account for 6.8GB, which would blow my 8GB laptop out of the water. It runs fine,<br />
 so most of that RSS value is not really independent of other processes.</p>
<p>The Proportional Shared Size (PSS) from&nbsp;<code>smem</code>&nbsp;might a better estimate we have of actual<br />
 memory usage, but in fact it is not that different from the RSS values:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ smem</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  PID User     Command                         Swap      USS      PSS      RSS</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">...</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">27435 dsyer    java -Xmx32m -Xss256k -jar         0   142340   142648   155516 </pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">27449 dsyer    java -Xmx32m -Xss256k -jar         0   142452   142758   155568 </pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">...</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">27441 dsyer    java -Xmx32m -Xss256k -jar         0   175156   175479   188796 </pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">27451 dsyer    java -Xmx32m -Xss256k -jar         0   175256   175579   188900 </pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">27463 dsyer    java -Xmx32m -Xss256k -jar         0   179592   179915   193224</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>We can hypothesize that maybe the PSS number is still hugely inflated by shared read-only memory (e.g. mapped jar files).</p>
<p>The 40 processes pretty much filled up the available memory on my laptop (3.6GB before the apps started), and some paging was happening, but not much. We can turn that into an estimate of the process<br />
 size: 3.6GB/40 = 90MB. Not far off the JConsole estimate.</p>
<h2>Do Nothing Plain Java App</h2>
<p>As a useful comparison point, let’s make a really basic Java application that stays alive when we run it so we can meaure its memory consumption:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">public class Main throws Exception {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  public static void main (String[] args) {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">    System.in.read();</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  }</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">}</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>Results: heap 6MB, non-heap 14MB (Code Cache 4MB, Compressed Class Space 1MB, Metaspace 9MB), 1500 classes. Hardly any classes loaded so no surprise really.</p>
<h2>Do Nothing Spring Boot App</h2>
<p>Now suppose we do the same thing but load a Spring application context as well:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">@SpringBootApplication</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">public class MainApplication implements ApplicationRunner {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  @Override</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  public void run(ApplicationArguments args) throws Exception {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">    System.in.read();</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  }</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  public static void main(String[] args) throws Exception {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">    SpringApplication.run(MainApplication.class, args);</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  }</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">}</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>Heap 12MB (but drops to 6MB after a manual GC), non-heap 26MB (Code Cache 7MB, Compressed Class Space 2MB, Metaspace 17MB), 3200 classes. The graph below shows the heap usage from launching the<br />
 app to the end state. The big drop in the middle is the manual GC, and you can see that after this the app stabilizes at a different saw tooth.</p>
<p><img referrerpolicy="no-referrer"src="https://raw.githubusercontent.com/dsyer/spring-boot-memory-blog/master/manual-gc.png"></p>
<p>Does Spring Boot itself (as opposed to just Spring) add a lot of overhead to this application? For starters, we can test that by removing the&nbsp;<code>@SpringBootApplication</code>&nbsp;annotation.<br />
 Doing that means that we load a context but don’t do any autoconfiguration. The result is: heap 11MB (drops to 5MB after a manual GC), non-heap 22MB (Code Cache 5MB, Compressed Class Space 2MB, Metaspace 15MB), 2700 classes. The Spring Boot autoconfiguration<br />
 premium, measured this way, is about 1MB heap and 4MB non-heap.</p>
<p>Going a step further, we can create a Spring application context manually without using any Spring Boot code at all. Doing this drops the heap usage to 10MB (drops to 5MB after a manual GC), non-heap<br />
 to 20MB (Code Cache 5MB, Compressed Class Space 2MB, Metaspace 13MB), 2400 classes. The Spring Boot total premium, measured this way, is less than 2MB heap and about 6MB non-heap memory.</p>
<h2>Ratpack Groovy App</h2>
<p>A simple Ratpack groovy app can be created using&nbsp;<a href="https://github.com/pledbrook/lazybones" rel="external nofollow noreferrer">lazybones</a>:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ lazybones create ratpack .</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ ./gradlew build</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ unzip build/distributions/ratpack.zip</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ JAVA_OPTS='-Xmx32m -Xss256k' ./ratpack/bin/ratpack</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">$ ls -l build/distributions/ratpack/lib/*.jar | awk '{tot&#043;=$5;} END {print tot}'</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">16277607</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>The used heap is pretty low to start with (13MB), grows to 22MB over time. Metaspace is about 34MB. JConsole reports 43MB non-heap usage. There are 31 threads.</p>
<h2>Ratpack Java App</h2>
<p>Here’s a really basic static app:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">import ratpack.server.BaseDir;</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">import ratpack.server.RatpackServer;</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">public class DemoApplication {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  public static void main(String[] args) throws Exception {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">    RatpackServer.start(s -&gt; s</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">        .serverConfig(c -&gt; c.baseDir(BaseDir.find()))</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">        .handlers(chain -&gt; chain</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">            .all(ctx -&gt; ctx.render(&quot;root handler!&quot;))</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">        )</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">    );</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  }</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">}</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>It runs in about 16MB heap, 28MB non-heap as a Spring Boot fat jar. As a regular gradle application it’s a bit lighter on heap (the cached jars aren’t needed) but uses the same non-heap memory.<br />
 There are 30 threads. Interestingly there is no object that is bigger than 300KB, whereas our Spring Boot apps with Tomcat generally have 10 or more objects above that level.</p>
<h2>Variations on the Vanilla App</h2>
<p>Running from exploded jar shaves up to 6MB off the heap (the difference is cached jar data in the launcher). Also makes startup a bit faster: less than 5s compared to as much as 7s when memory is<br />
 constrained with the fat jar.</p>
<p>A slimmed down version of the app with no static resources or webjars runs at 23MB heap and 41MB non-heap as exploded archive (starts in less than 3s). The non-heap usage breaks down as Metaspace:<br />
 35MB, Compressed Class Space: 4MB, Code Cache: 4MB. Spring&nbsp;<code>ReflectionUtils</code>&nbsp;jumps to near the top of the memory chart in YourKit with Spring 4.2.3<br />
 (2nd only to Tomcat&nbsp;<code>NioEndpoint</code>). The&nbsp;<code>ReflectionUtils</code>&nbsp;should<br />
 shrink under memory pressure but they don’t in practice so Spring 4.2.4&nbsp;<a href="https://jira.spring.io/browse/SPR-13783" rel="external nofollow noreferrer">clears the caches</a>&nbsp;once the context has<br />
 started, resulting in some memory savings (down to about 20MB heap).&nbsp;<code>DefaultListableBeanFactory</code>&nbsp;drops down to 3rd place and is almost half the size<br />
 it was with the resource chain (webjars locator) but it won’t shrink any further without removing more features.</p>
<p>In turns out that the&nbsp;<code>NioEndpoint</code>&nbsp;has a 1MB “oom parachute” that it holds onto until<br />
 it detects an<code>OutOfMemoryError</code>. You can customize it to zero and forgo the parachute to save an extra MB of heap, e.g:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">@SpringBootApplication</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">public class SlimApplication implements EmbeddedServletContainerCustomizer {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  @Override</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  public void customize(ConfigurableEmbeddedServletContainer container) {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">    if (container instanceof TomcatEmbeddedServletContainerFactory) {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">      TomcatEmbeddedServletContainerFactory tomcat = (TomcatEmbeddedServletContainerFactory) container;</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">      tomcat.addConnectorCustomizers(connector -&gt; {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">        ProtocolHandler handler = connector.getProtocolHandler();</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">        if (handler instanceof Http11NioProtocol) {</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">          Http11NioProtocol http = (Http11NioProtocol) handler;</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">          http.getEndpoint().setOomParachute(0);</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">        }</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">      });</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">    }</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">  }</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">...</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">}</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>Using Jetty instead of Tomcat makes no difference whatsoever to the overall memory or heap, even though the&nbsp;<code>NioEndpoint</code>&nbsp;is<br />
 high on the “Biggest objects” list in YourKit (takes about 1MB), and there is no corresponding blip for Jetty. It also doesn’t start up any quicker.</p>
<p>As an example of a “real” Spring Boot app, Zipkin (Java) runs fine with with&nbsp;<code>-Xmx32m -Xss256k</code>,<br />
 at least for short periods. It settles with a heap of about 24MB and non-heap about 55MB.</p>
<p>The&nbsp;<code>spring-cloud-stream</code>&nbsp;sample sink (with Redis transport) also runs fine with&nbsp;<code>-Xmx32m<br />
 -Xss256k</code>&nbsp;and similar memory usage profile (i.e. roughly 80MB total). The actuator endpoints are active but don’t do much to the memory profile. Slightly slower startup maybe.</p>
<h2>Tomcat Container</h2>
<p>Instead of using the emedded container in Spring Boot, what if we deploy a traditional war file to a Tomcat container?</p>
<p><img referrerpolicy="no-referrer"src="https://raw.githubusercontent.com/dsyer/spring-boot-memory-blog/master/manual-gc-tomcat.png"></p>
<p>The container starts and warms up a bit and uses of order 50MB heap, and 40MB non-heap. Then we deploy a war of the vanilla Spring Boot app, and there’s a spike in heap usage, which settles down<br />
 to about 100MB. We do a manual GC and it drops down to below 50MB, and then add some load and it jumps up to about 140MB. A manual GC drops it back down to below 50MB. So we have no reason to believe this app is really using much if any additional heap compared<br />
 to the container. It uses some when under load, but it can always reclaim it under GC pressure.</p>
<p>Metaspace, however tells a different story, it goes up from 14MB to 41MB in the single app under load. Total non-heap usage is reported at 59MB in the final state.</p>
<h3>Deploy Another Application</h3>
<p>If we add another copy of the same application to the Tomcat container, trough heap consumption goes up a bit (above 50MB) and metaspace is up to 55MB. Under load heap usage jumps to 250MB or so,<br />
 but always seems to be reclaimable.</p>
<p>Then we add some more apps. With six apps deployed the metaspace is up to 115MB and total non-heap to 161MB. This is consistent with what we saw for a single app: each one costs us about 20MB non-heap<br />
 memory. Heap usage hits 400MB under load, so this doesn’t go up proportionally (however it is being managed from above, so maybe that’s not surprising). The trough of heap usage is up to about 130MB, so the cumulative effect of adding apps on the heap is visible<br />
 there (about 15MB per app).</p>
<p>When we constrain Tomcat to the same amount of heap that the six apps would have in our vanilla embedded launch (<code>-Xmx192m</code>)<br />
 the heap under load is more or less at its limit (190MB), and the trough after a manual GC is 118MB. Non-heap memory is reported as 154MB. The heap trough and non-heap usage is not identical but consistent with the unconstrained Tomcat instance (which actually<br />
 had a 1GB heap). Compared to the embedded containers the total memory usage, including the full heap, is a bit smaller because some of the non-heap memory is apparently shared between apps (344MB compared to 492MB). For more realistic apps that require more<br />
 heap themselves the difference will not be proportionally as big (50MB out of 8GB is negligible). Also any app that manages its own thread pool (not uncommon in real life Spring applications) will incur an additional non-heap memory penalty for the threads<br />
 it needs.</p>
<h2>Rule of Thumb Process Sizes</h2>
<p>A very rough estimate for actual memory usage would be the heap size plus 20 times the stack size (for the 20 threads typical in a servlet container), plus a bit, so maybe 40MB per process in our<br />
 vanilla app. That estimate is a bit low, given the JConsole numbers (50MB plus the heap, or 82MB). We can observe, though, that the non-heap usage in our apps is roughly proportional to the number of classes loaded. Once you correct for the stack size the<br />
 correlation improves, so a better rule of thumb might be one that is proportional to the number of classes loaded:</p>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">memory = heap &#043; non-heap</pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums"></pre>
</div>
<div>
<div>
<div>
</div>
</div>
<pre class="prettyprint linenums">non-heap = threads x stack &#043; classes x 7/1000</pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<div>
</div>
</div>
</div>
</div>
<p>The vanilla app loads about 6000 classes and the do nothing Java main loads about 1500. The estimate is accurate for the vanilla app and the do nothing Java app.</p>
<p>Adding Spring Cloud Eureka discovery only loads about another 1500 classes, and uses about 40 threads, so it should use a bit more non-heap memory, but not a lot (and indeed it does use about 70MB<br />
 with 256KB stacks, where the rule of thumb would predict 63MB).</p>
<p>The performance of this model for the apps we measured is shown below:</p>
<p><img referrerpolicy="no-referrer"src="https://raw.githubusercontent.com/dsyer/spring-boot-memory-blog/master/non-heap-correlation.png"></p>
<h2>Summary of Data</h2>
<p>Application Heap (MB) Non Heap (MB) Threads Classes Vanilla 22 50 25 6200 Plain Java 6 14 11 1500 Spring Boot 6 26 11 3200 No Actuator 5 22 11 2700 Spring Only 5 20 11 2400 Eureka Client 80* 70<br />
 40 7600 Ratpack Groovy 22 43 24 5300 Ratpack Java 16 28 22 3000</p>
<p>* Only the Eureka client has a larger heap: all the others are set<br /><br />
explicitly to&nbsp;<code>-Xmx32m</code>.</p>
<h2>Conclusions</h2>
<p>The effect Spring Boot on its own has on a Java application is to use a bit more heap and non-heap memory, mostly because of extra classes it has to load. The difference can be quantified as roughly<br />
 an extra 2MB heap and 12MB non-heap. In a real application that might consume many times as much for actual business purposes this is pretty insignificant. The difference between vanilla Spring and Spring Boot is a few MB total (neither here nor there really).<br />
 The Spring Boot team have only just started measuring things in this level of detail so we can probably expect optimizations in the future anyway. When we compare memory usage for apps deployed in a single Tomcat container with the same apps deployed as independent<br />
 processes, not surprisingly the single container packs the apps more densely in memory. The penalty for a standalone process is mainly related to non-heap usage though, which adds up to maybe 30MB per app when the number of apps is much larger than the number<br />
 of containers (and less otherwise). We wouldn’t expect this to increase as apps use more heap, so in most real apps it is not significant. The benefits of deploying an app as an independent process following the&nbsp;<a href="http://12factor.net/" rel="external nofollow noreferrer">twelve-factor</a>&nbsp;and<br />
 Cloud Native principles outweigh the cost of using a bit more memory in our opinion. As a final note, we observe that the native tools in the operating system are not nearly as good as the ones provided by the JVM, when you want to inspect a process and find<br />
 out about its memory usage.</p>
</div>
<div>
The Performance Zone is brought to you in partnership with&nbsp;<a href="https://dzone.com/go?i=83824&amp;u=http%3A%2F%2Fnewrelic.com%2Fcloud-cookbook-enterprise%3Futm_source%3DZONE%26utm_medium%3Dcontent%26utm_content%3Dmigrating-to-the-cloud%26utm_campaign%3DNonENTGeneric-Q3FY16%26mpc%3DCN-ZONE-generic-EN-Signup-migrating-to-the-cloud" rel="external nofollow noreferrer">New<br />
 Relic</a>. Read more about&nbsp;providing a framework that gets you started on the right path to move your IT services to&nbsp;<a href="https://dzone.com/go?i=83824&amp;u=http%3A%2F%2Fnewrelic.com%2Fcloud-cookbook-enterprise%3Futm_source%3DZONE%26utm_medium%3Dcontent%26utm_content%3Dmigrating-to-the-cloud%26utm_campaign%3DNonENTGeneric-Q3FY16%26mpc%3DCN-ZONE-generic-EN-Signup-migrating-to-the-cloud" rel="external nofollow noreferrer">cloud<br />
 computing</a>, and give you an understanding as to why certain applications should not move to the cloud.</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q71lm1q.html">linux应用与发展（上）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o07w39.html">Python 迭代删除重复项，集合删除重复项</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mndrw0q.html">java&period;lang&period;ClassCastException&colon; sun&period;jdbc&period;odbc&period;JdbcOdbcStatement cannot be cast to java&period;beans&period;Statement</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xm7rm8.html">sudo 权限问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdx1j38.html">【转】Mac和iOS开发资源汇总&mdash;更新于2013-07-19</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xloyz9.html">nyoj 2 括号配对问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1znm269.html">SharePoint 文档库实现文件夹拖放到文档库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmg2m19.html">cacti出现snmp error</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yjnlr8.html">java IO类图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj5w2y8.html">js实现的文章输入检查与测速。</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yvmrn8.html">web存储之webstorage</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gerpg78.html">JavaScript正则表达式实例汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljgyv19.html">java程序启动 环境属性的获取</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj01z69.html">Windows环境下最新OpenCV和Contribute代码的联合编译【20180926更新红字】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy166v9.html">sql base and plsql and database</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjd239.html">c&num;  导入导出excel方法封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9607xy39.html">zookeeperCli和Java操作zookeeperAPI</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvwnvk8.html">Linux3&period;10&period;0块IO子系统流程（0）-- 块IO子系统概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2wr39.html">SSH框架整合，css、js会被过滤器过滤掉</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25evy3q.html">（转）Fur Shader</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlmznwe9.html">在WHERE子句中引用取别名的列</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmzn7e9.html">Java并发编程：Thread类的使用介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w7movq.html">学会用这二个键，你就是电脑高手了，一个是Win键，另一个是Ctrl！</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mpl4kq.html">SQlSERVER生成唯一编号</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmz56k9.html">ASP&period;NET MVC  Controller向View传值方式总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1pj7x9.html">java堆溢出的小栗子</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yedy3q.html">Java学习之ThreadLocal</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1pwgk9.html">网络技术教程笔记&lpar;18）常见广域网技术&mdash;&mdash;X&period;25与郑中基技术（&larr;&lowbar;&larr;搜狗输入法你够了）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o6drv9.html">hadoop搭建杂记：Linux下hostname的更改办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd7w1z8.html">JQuery的Select操作集合</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
